PLM之家精品课程培训,联系电话:18301858168 QQ: 939801026

  • NX二次开培训

    NX二次开培训

    适合初级入门或想深入了解二次开发的工程师,本培训结合ufun,NXOpen C++,大量的实例及官方内部的开发技术对于老鸟也值得借鉴!.

    NX CAM二次开发培训报名 NX二次开发基础培训报名
  • PLM之家Catia CAA二次开发培训

    Catia二次开发培训

    Catia二次开发的市场大,这方面开发人才少,难度大。所以只要你掌握了开发,那么潜力巨大,随着时间的积累,你必将有所用武之地!

  • PLM之Teamcenter最佳学习方案

    Teamcenter培训

    用户应用基础培训,管理员基础培训,管理员高级培训,二次开发培训应有尽有,只要你感兴趣肯学习,专业多年经验大师级打造!

  • PLM之Tecnomatix制造领域培训

    Tecnomatix培训

    想了解制造领域数字化吗?想了解工厂,生产线设计吗?数字化双胞胎,工业4.0吗?我们的课程虚位以待!

PLM之家PLMHome-国产软件践行者

[二次开发源码] 教你如何通过NXOpen C++通过session 找part,part找body,body找face...

[复制链接]

2014-3-18 16:55:13 3259 0

admin 发表于 2014-3-18 16:55:13 |阅读模式

admin 楼主

2014-3-18 16:55:13

请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!

您需要 登录 才可以下载或查看,没有账号?注册

x
The examples show how to access the following relationships:
- {2 l5 {0 f: K  y8 g/ l. `
  • NX session → list of parts
  • part → list of solid bodies
  • solid body → list of faces
    solid body → list of edges
  • face → list of associated edges
    face → solid body
  • edge → list of associated faces
    edge → solid body

    ! O- X0 O) Y# O/ M0 h, y
! k5 M9 v6 U2 K% c3 k% T; W
Bodies, Faces and Edges - Language Specific Details& B: `6 u1 `& Q. ~' d1 U
NX Open for C++
NX Open for .NET
NX Open for Java

, D( _4 }6 j( d( G( H6 q( h; b6 L& b/ I7 l' t" \5 O1 Y
NX Open for C++
6 a7 c) [8 C# }$ {
. y# l! N- x9 F0 V* V- y% T3 z
2 W2 K! s* i  {! o9 s) o- xNX session → list of parts
  X8 [3 q2 a; r
To access all parts in an NX session, use the Parts property to access the Part Collection.  Then use the collection's iterator to access each part.
  Session *NXSession = Session::GetSession();   ParTCollection *partList = NXSession->Parts();  PartCollection::iterator itr;  for ( itr = partList->begin(); itr != partList->end(); ++itr )  {   processPart(*itr);  }5 G5 c4 \# Z5 q( q( U

. |2 I& `) s9 f5 T1 v  ]part → list of solid bodies. D) k* |: _2 b% }
To access all solid bodies in a part, use the Bodies property to access the Body Collection. Then use the collection's iterator to access each body.
void processPart(Part *partObject){   BodyCollection *bodyList = partObject->Bodies();   BodyCollection::iterator itr;   for (itr = bodyList->begin(); itr != bodyList->end(); ++itr)   {    processBodyFaces(*itr);    processBodyEdges(*itr);   }}" t8 K* `$ R* D* n
, @" p% U2 u! G( h- N8 O
solid body → list of faces2 ^# B( v  ?% M2 C& a
To access the faces of a body use the GetFaces() method to return an array of faces.
void processBodyEdges(Body *bodyObject){    std::vector <Edge *> edgeArray = bodyObject->GetEdges();    for (int inx = 0;  inx < (int)edgeArray.size(); ++inx)          {                        processEdge(edgeArray[inx]);          }}
9 W! U% v' H- o) X1 ^/ P' K* x0 ^2 h; D3 e2 r$ r
solid body → list of edges8 F  v$ _: a3 u; _/ m. d
To access the edges in a body use the GetEdges() method to return an array of edges.
void processBodyEdges(Body *bodyObject){    std::vector <Edge *> edgeArray = bodyObject->GetEdges();    for (int inx = 0;  inx < (int)edgeArray.size(); ++inx)    {    processEdge(edgeArray[inx]);    }} ' k4 m" R0 @, |6 e* x; K
6 E, \  ~0 g6 e
face → list of associated edges
8 Z! u/ J3 d/ g6 }: Kface → solid body
) \1 S& D$ r& q6 }) I
To access the edges for a face use the GetEdges() method to return an array of edges. To access the face's body use the GetBody() method.
void processFace(Face *faceObject){        std::vector<Edge *> edgeArray = faceObject->GetEdges();        for (int inx = 0;  inx < (int)edgeArray.size(); ++inx)        {                processEdge(edgeArray[inx]);        }        Body *bodyOfFace = faceObject->GetBody();}
- K' v9 o, V) ^! h/ C! O6 z) k
( ]. q5 c5 _( k& G2 Ledge → list of associated faces5 f( ~( W: u: r( l; b7 O6 O9 C+ c1 F
edge → solid body
5 \; {0 P9 m" d% F, m3 `. d
To access the faces associated with and edge use the GetFaces() method to return an array of faces. To access the edge's body use the GetBody() method.
void processEdge(Edge *edgeObject){        std::vector<Face *> faceArray = edgeObject->GetFaces();        for (int inx = 0;  inx < (int)faceArray.size(); ++inx)        {                processEdgeFace(faceArray[inx]);        }        Body *bodyOfEdge = edgeObject->GetBody();}
/ {5 q/ f3 b. c0 R) X5 W5 s7 G
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 注册

返回列表 本版积分规则

  • 发布新帖

  • 在线客服

  • 微信

  • 客户端

  • 返回顶部

  • x
    温馨提示

    本网站(plmhome.com)为PLM之家工业软件学习官网站

    展示的视频材料全部免费,需要高清和特殊技术支持请联系 QQ: 939801026

    PLM之家NX CAM二次开发专题模块培训报名开始啦

    我知道了